<center><a href="cn.c">Actual source code: cn.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:32:07+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCTS_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/*</font>
<a name="line4">  4: </a><font color="#B22222">       Code for Timestepping with implicit Crank-Nicholson method.</font>
<a name="line5">  5: </a><font color="#B22222">    THIS <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> NOT YET COMPLETE -- DO NOT USE!!</font>
<a name="line6">  6: </a><font color="#B22222">*/</font>
<a name="line7"> 7: </a> #include <A href="../../../../../src/ts/tsimpl.h.html">src/ts/tsimpl.h</A>

<a name="line9">  9: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line10"> 10: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>  update;      <font color="#B22222">/* work vector where new solution is formed */</font>
<a name="line11"> 11: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>  func;        <font color="#B22222">/* work vector where F(t[i],u[i]) is stored */</font>
<a name="line12"> 12: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>  rhs;         <font color="#B22222">/* work vector for RHS; vec_sol/dt */</font>
<a name="line13"> 13: </a>} <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>;

<a name="line15"> 15: </a><font color="#B22222">/*------------------------------------------------------------------------------*/</font>
<a name="line18"> 18: </a><font color="#B22222">/*</font>
<a name="line19"> 19: </a><font color="#B22222">   TSComputeRHSFunctionEuler - Evaluates the right-hand-side function. </font>

<a name="line21"> 21: </a><font color="#B22222">   Note: If the user did not provide a function but merely a matrix,</font>
<a name="line22"> 22: </a><font color="#B22222">   this routine applies the matrix.</font>
<a name="line23"> 23: </a><font color="#B22222">*/</font>
<a name="line24"> 24: </a><strong><font color="#4169E1"><a name="TSComputeRHSFunctionEuler"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSComputeRHSFunctionEuler(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> t,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> y)</font></strong>
<a name="line25"> 25: </a>{
<a name="line27"> 27: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    neg_two = -2.0,neg_mdt = -1.0/ts-&gt;time_step;


<a name="line34"> 34: </a>  <font color="#4169E1">if</font> (ts-&gt;ops-&gt;rhsfunction) {
<a name="line35"> 35: </a>    PetscStackPush(<font color="#666666">"<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> user right-hand-side function"</font>);
<a name="line36"> 36: </a>    (*ts-&gt;ops-&gt;rhsfunction)(ts,t,x,y,ts-&gt;funP);
<a name="line37"> 37: </a>    PetscStackPop;
<a name="line38"> 38: </a>    <font color="#4169E1">return</font>(0);
<a name="line39"> 39: </a>  }

<a name="line41"> 41: </a>  <font color="#4169E1">if</font> (ts-&gt;ops-&gt;rhsmatrix) { <font color="#B22222">/* assemble matrix for this timestep */</font>
<a name="line42"> 42: </a>    <A href="../../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A> flg;
<a name="line43"> 43: </a>    PetscStackPush(<font color="#666666">"<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> user right-hand-side matrix function"</font>);
<a name="line44"> 44: </a>    (*ts-&gt;ops-&gt;rhsmatrix)(ts,t,&amp;ts-&gt;A,&amp;ts-&gt;B,&amp;flg,ts-&gt;jacP);
<a name="line45"> 45: </a>    PetscStackPop;
<a name="line46"> 46: </a>  }
<a name="line47"> 47: </a>  <A href="../../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(ts-&gt;A,x,y);
<a name="line48"> 48: </a>  <font color="#B22222">/* shift: y = y -2*x */</font>
<a name="line49"> 49: </a>  <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(y,neg_two,x);
<a name="line50"> 50: </a>  <font color="#B22222">/* scale: y = y -2*x */</font>
<a name="line51"> 51: </a>  <A href="../../../../../docs/manualpages/Vec/VecScale.html#VecScale">VecScale</A>(y,neg_mdt);

<a name="line53"> 53: </a>  <font color="#4169E1">return</font>(0);
<a name="line54"> 54: </a>}

<a name="line56"> 56: </a><font color="#B22222">/*</font>
<a name="line57"> 57: </a><font color="#B22222">    Version for linear PDE where RHS does not depend on time. Has built a</font>
<a name="line58"> 58: </a><font color="#B22222">  single matrix that is to be used for all timesteps.</font>
<a name="line59"> 59: </a><font color="#B22222">*/</font>
<a name="line62"> 62: </a><strong><font color="#4169E1"><a name="TSStep_CN_Linear_Constant_Matrix"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSStep_CN_Linear_Constant_Matrix(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *steps,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *ptime)</font></strong>
<a name="line63"> 63: </a>{
<a name="line64"> 64: </a>  <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>          *cn = (<A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>*)ts-&gt;data;
<a name="line65"> 65: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            sol = ts-&gt;vec_sol,update = cn-&gt;update;
<a name="line66"> 66: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            rhs = cn-&gt;rhs;
<a name="line68"> 68: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,max_steps = ts-&gt;max_steps,its;
<a name="line69"> 69: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    dt = ts-&gt;time_step,two = 2.0;
<a name="line70"> 70: </a>  <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>            ksp;

<a name="line73"> 73: </a>  <A href="../../../../../docs/manualpages/TS/TSGetKSP.html#TSGetKSP">TSGetKSP</A>(ts,&amp;ksp);
<a name="line74"> 74: </a>  *steps = -ts-&gt;steps;
<a name="line75"> 75: </a>  TSMonitor(ts,ts-&gt;steps,ts-&gt;ptime,sol);

<a name="line77"> 77: </a>  <font color="#B22222">/* set initial guess to be previous solution */</font>
<a name="line78"> 78: </a>  <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(sol,update);

<a name="line80"> 80: </a>  <font color="#4169E1">for</font> (i=0; i&lt;max_steps; i++) {
<a name="line81"> 81: </a>    ts-&gt;ptime += ts-&gt;time_step;
<a name="line82"> 82: </a>    <font color="#4169E1">if</font> (ts-&gt;ptime &gt; ts-&gt;max_time) <font color="#4169E1">break</font>;

<a name="line84"> 84: </a>    <font color="#B22222">/* phase 1 - explicit step */</font>
<a name="line85"> 85: </a>    TSComputeRHSFunctionEuler(ts,ts-&gt;ptime,sol,update);
<a name="line86"> 86: </a>    <A href="../../../../../docs/manualpages/Vec/VecAXPBY.html#VecAXPBY">VecAXPBY</A>(sol,dt,two,update);

<a name="line88"> 88: </a>    <font color="#B22222">/* phase 2 - implicit step */</font>
<a name="line89"> 89: </a>    <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(sol,rhs);

<a name="line91"> 91: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(ts-&gt;ksp,rhs,update);
<a name="line92"> 92: </a>    <A href="../../../../../docs/manualpages/KSP/KSPGetIterationNumber.html#KSPGetIterationNumber">KSPGetIterationNumber</A>(ksp,&amp;its);
<a name="line93"> 93: </a>    ts-&gt;linear_its += <A href="../../../../../docs/manualpages/Sys/PetscAbsInt.html#PetscAbsInt">PetscAbsInt</A>(its);
<a name="line94"> 94: </a>    <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(update,sol);
<a name="line95"> 95: </a>    ts-&gt;steps++;
<a name="line96"> 96: </a>    TSMonitor(ts,ts-&gt;steps,ts-&gt;ptime,sol);
<a name="line97"> 97: </a>  }

<a name="line99"> 99: </a>  *steps += ts-&gt;steps;
<a name="line100">100: </a>  *ptime  = ts-&gt;ptime;
<a name="line101">101: </a>  <font color="#4169E1">return</font>(0);
<a name="line102">102: </a>}
<a name="line103">103: </a><font color="#B22222">/*</font>
<a name="line104">104: </a><font color="#B22222">      Version where matrix depends on time </font>
<a name="line105">105: </a><font color="#B22222">*/</font>
<a name="line108">108: </a><strong><font color="#4169E1"><a name="TSStep_CN_Linear_Variable_Matrix"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSStep_CN_Linear_Variable_Matrix(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *steps,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *ptime)</font></strong>
<a name="line109">109: </a>{
<a name="line110">110: </a>  <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>          *cn = (<A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>*)ts-&gt;data;
<a name="line111">111: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            sol = ts-&gt;vec_sol,update = cn-&gt;update,rhs = cn-&gt;rhs;
<a name="line113">113: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,max_steps = ts-&gt;max_steps,its;
<a name="line114">114: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    dt = ts-&gt;time_step,two = 2.0;
<a name="line115">115: </a>  <A href="../../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A>   str;
<a name="line116">116: </a>  <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>            ksp;

<a name="line119">119: </a>  <A href="../../../../../docs/manualpages/TS/TSGetKSP.html#TSGetKSP">TSGetKSP</A>(ts,&amp;ksp);
<a name="line120">120: </a>  *steps = -ts-&gt;steps;
<a name="line121">121: </a>  TSMonitor(ts,ts-&gt;steps,ts-&gt;ptime,sol);

<a name="line123">123: </a>  <font color="#B22222">/* set initial guess to be previous solution */</font>
<a name="line124">124: </a>  <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(sol,update);

<a name="line126">126: </a>  <font color="#4169E1">for</font> (i=0; i&lt;max_steps; i++) {
<a name="line127">127: </a>    ts-&gt;ptime += ts-&gt;time_step;
<a name="line128">128: </a>    <font color="#4169E1">if</font> (ts-&gt;ptime &gt; ts-&gt;max_time) <font color="#4169E1">break</font>;
<a name="line129">129: </a>    <font color="#B22222">/*</font>
<a name="line130">130: </a><font color="#B22222">        evaluate matrix function </font>
<a name="line131">131: </a><font color="#B22222">    */</font>
<a name="line132">132: </a>    (*ts-&gt;ops-&gt;rhsmatrix)(ts,ts-&gt;ptime,&amp;ts-&gt;A,&amp;ts-&gt;B,&amp;str,ts-&gt;jacP);
<a name="line133">133: </a>    TSScaleShiftMatrices(ts,ts-&gt;A,ts-&gt;B,str);

<a name="line135">135: </a>    <font color="#B22222">/* phase 1 - explicit step */</font>
<a name="line136">136: </a>    TSComputeRHSFunctionEuler(ts,ts-&gt;ptime,sol,update);
<a name="line137">137: </a>    <A href="../../../../../docs/manualpages/Vec/VecAXPBY.html#VecAXPBY">VecAXPBY</A>(sol,dt,two,update);

<a name="line139">139: </a>    <font color="#B22222">/* phase 2 - implicit step */</font>
<a name="line140">140: </a>    <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(sol,rhs);

<a name="line142">142: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSetOperators.html#KSPSetOperators">KSPSetOperators</A>(ts-&gt;ksp,ts-&gt;A,ts-&gt;B,str);
<a name="line143">143: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(ts-&gt;ksp,rhs,update);
<a name="line144">144: </a>    <A href="../../../../../docs/manualpages/KSP/KSPGetIterationNumber.html#KSPGetIterationNumber">KSPGetIterationNumber</A>(ksp,&amp;its);
<a name="line145">145: </a>    ts-&gt;linear_its += <A href="../../../../../docs/manualpages/Sys/PetscAbsInt.html#PetscAbsInt">PetscAbsInt</A>(its);
<a name="line146">146: </a>    <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(update,sol);
<a name="line147">147: </a>    ts-&gt;steps++;
<a name="line148">148: </a>    TSMonitor(ts,ts-&gt;steps,ts-&gt;ptime,sol);
<a name="line149">149: </a>  }

<a name="line151">151: </a>  *steps += ts-&gt;steps;
<a name="line152">152: </a>  *ptime  = ts-&gt;ptime;
<a name="line153">153: </a>  <font color="#4169E1">return</font>(0);
<a name="line154">154: </a>}
<a name="line155">155: </a><font color="#B22222">/*</font>
<a name="line156">156: </a><font color="#B22222">    Version for nonlinear PDE.</font>
<a name="line157">157: </a><font color="#B22222">*/</font>
<a name="line160">160: </a><strong><font color="#4169E1"><a name="TSStep_CN_Nonlinear"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSStep_CN_Nonlinear(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *steps,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *ptime)</font></strong>
<a name="line161">161: </a>{
<a name="line162">162: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            sol = ts-&gt;vec_sol;
<a name="line164">164: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,max_steps = ts-&gt;max_steps,its,lits;
<a name="line165">165: </a>  <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>          *cn = (<A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>*)ts-&gt;data;
<a name="line166">166: </a>
<a name="line168">168: </a>  *steps = -ts-&gt;steps;
<a name="line169">169: </a>  TSMonitor(ts,ts-&gt;steps,ts-&gt;ptime,sol);

<a name="line171">171: </a>  <font color="#4169E1">for</font> (i=0; i&lt;max_steps; i++) {
<a name="line172">172: </a>    ts-&gt;ptime += ts-&gt;time_step;
<a name="line173">173: </a>    <font color="#4169E1">if</font> (ts-&gt;ptime &gt; ts-&gt;max_time) <font color="#4169E1">break</font>;
<a name="line174">174: </a>    <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(sol,cn-&gt;update);
<a name="line175">175: </a>    <A href="../../../../../docs/manualpages/SNES/SNESSolve.html#SNESSolve">SNESSolve</A>(ts-&gt;snes,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,cn-&gt;update);
<a name="line176">176: </a>    <A href="../../../../../docs/manualpages/SNES/SNESGetIterationNumber.html#SNESGetIterationNumber">SNESGetIterationNumber</A>(ts-&gt;snes,&amp;its);
<a name="line177">177: </a>    <A href="../../../../../docs/manualpages/SNES/SNESGetNumberLinearIterations.html#SNESGetNumberLinearIterations">SNESGetNumberLinearIterations</A>(ts-&gt;snes,&amp;lits);
<a name="line178">178: </a>    ts-&gt;nonlinear_its += its; ts-&gt;linear_its += lits;
<a name="line179">179: </a>    <A href="../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(cn-&gt;update,sol);
<a name="line180">180: </a>    ts-&gt;steps++;
<a name="line181">181: </a>    TSMonitor(ts,ts-&gt;steps,ts-&gt;ptime,sol);
<a name="line182">182: </a>  }

<a name="line184">184: </a>  *steps += ts-&gt;steps;
<a name="line185">185: </a>  *ptime  = ts-&gt;ptime;
<a name="line186">186: </a>  <font color="#4169E1">return</font>(0);
<a name="line187">187: </a>}

<a name="line189">189: </a><font color="#B22222">/*------------------------------------------------------------*/</font>
<a name="line192">192: </a><strong><font color="#4169E1"><a name="TSDestroy_CN"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSDestroy_CN(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line193">193: </a>{
<a name="line194">194: </a>  <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>          *cn = (<A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>*)ts-&gt;data;

<a name="line198">198: </a>  <font color="#4169E1">if</font> (cn-&gt;update) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(cn-&gt;update);}
<a name="line199">199: </a>  <font color="#4169E1">if</font> (cn-&gt;func) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(cn-&gt;func);}
<a name="line200">200: </a>  <font color="#4169E1">if</font> (cn-&gt;rhs) {<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(cn-&gt;rhs);}
<a name="line201">201: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(cn);
<a name="line202">202: </a>  <font color="#4169E1">return</font>(0);
<a name="line203">203: </a>}

<a name="line205">205: </a><font color="#B22222">/* </font>
<a name="line206">206: </a><font color="#B22222">    This defines the nonlinear equation that is to be solved with <A href="../../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A></font>

<a name="line208">208: </a><font color="#B22222">              U^{n+1} - dt*F(U^{n+1}) - U^{n}</font>
<a name="line209">209: </a><font color="#B22222">*/</font>
<a name="line212">212: </a><strong><font color="#4169E1"><a name="TSCnFunction"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSCnFunction(<A href="../../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> snes,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> y,void *ctx)</font></strong>
<a name="line213">213: </a>{
<a name="line214">214: </a>  <A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A>             ts = (<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A>) ctx;
<a name="line215">215: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    mdt = 1.0/ts-&gt;time_step,*unp1,*un,*Funp1;
<a name="line217">217: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n;

<a name="line220">220: </a>  <font color="#B22222">/* apply user provided function */</font>
<a name="line221">221: </a>  TSComputeRHSFunction(ts,ts-&gt;ptime,x,y);
<a name="line222">222: </a>  <font color="#B22222">/* (u^{n+1} - U^{n})/dt - F(u^{n+1}) */</font>
<a name="line223">223: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(ts-&gt;vec_sol,&amp;un);
<a name="line224">224: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(x,&amp;unp1);
<a name="line225">225: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(y,&amp;Funp1);
<a name="line226">226: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetLocalSize.html#VecGetLocalSize">VecGetLocalSize</A>(x,&amp;n);

<a name="line228">228: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line229">229: </a>    Funp1[i] = mdt*(unp1[i] - un[i]) - Funp1[i];
<a name="line230">230: </a>  }
<a name="line231">231: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(ts-&gt;vec_sol,&amp;un);
<a name="line232">232: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(x,&amp;unp1);
<a name="line233">233: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(y,&amp;Funp1);
<a name="line234">234: </a>  <font color="#4169E1">return</font>(0);
<a name="line235">235: </a>}

<a name="line237">237: </a><font color="#B22222">/*</font>
<a name="line238">238: </a><font color="#B22222">   This constructs the Jacobian needed for <A href="../../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> </font>

<a name="line240">240: </a><font color="#B22222">             J = I/dt - J_{F}   where J_{F} is the given Jacobian of F.</font>
<a name="line241">241: </a><font color="#B22222">*/</font>
<a name="line244">244: </a><strong><font color="#4169E1"><a name="TSCnJacobian"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSCnJacobian(<A href="../../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> snes,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *AA,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *BB,<A href="../../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A> *str,void *ctx)</font></strong>
<a name="line245">245: </a>{
<a name="line246">246: </a>  <A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A>             ts = (<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A>) ctx;

<a name="line250">250: </a>  <font color="#B22222">/* construct user's Jacobian */</font>
<a name="line251">251: </a>  <A href="../../../../../docs/manualpages/TS/TSComputeRHSJacobian.html#TSComputeRHSJacobian">TSComputeRHSJacobian</A>(ts,ts-&gt;ptime,x,AA,BB,str);

<a name="line253">253: </a>  <font color="#B22222">/* shift and scale Jacobian */</font>
<a name="line254">254: </a>  TSScaleShiftMatrices(ts,*AA,*BB,*str);
<a name="line255">255: </a>  <font color="#4169E1">return</font>(0);
<a name="line256">256: </a>}

<a name="line258">258: </a><font color="#B22222">/* ------------------------------------------------------------*/</font>
<a name="line261">261: </a><strong><font color="#4169E1"><a name="TSSetUp_CN_Linear_Constant_Matrix"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSSetUp_CN_Linear_Constant_Matrix(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line262">262: </a>{
<a name="line263">263: </a>  <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>          *cn = (<A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>*)ts-&gt;data;

<a name="line267">267: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(ts-&gt;vec_sol,&amp;cn-&gt;update);
<a name="line268">268: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(ts-&gt;vec_sol,&amp;cn-&gt;rhs);
<a name="line269">269: </a>
<a name="line270">270: </a>  <font color="#B22222">/* build linear system to be solved */</font>
<a name="line271">271: </a>  TSScaleShiftMatrices(ts,ts-&gt;A,ts-&gt;B,SAME_NONZERO_PATTERN);
<a name="line272">272: </a>  <A href="../../../../../docs/manualpages/KSP/KSPSetOperators.html#KSPSetOperators">KSPSetOperators</A>(ts-&gt;ksp,ts-&gt;A,ts-&gt;B,SAME_NONZERO_PATTERN);
<a name="line273">273: </a>  <font color="#4169E1">return</font>(0);
<a name="line274">274: </a>}

<a name="line278">278: </a><strong><font color="#4169E1"><a name="TSSetUp_CN_Linear_Variable_Matrix"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSSetUp_CN_Linear_Variable_Matrix(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line279">279: </a>{
<a name="line280">280: </a>  <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>          *cn = (<A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>*)ts-&gt;data;

<a name="line284">284: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(ts-&gt;vec_sol,&amp;cn-&gt;update);
<a name="line285">285: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(ts-&gt;vec_sol,&amp;cn-&gt;rhs);
<a name="line286">286: </a>  <font color="#4169E1">return</font>(0);
<a name="line287">287: </a>}

<a name="line291">291: </a><strong><font color="#4169E1"><a name="TSSetUp_CN_Nonlinear"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSSetUp_CN_Nonlinear(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line292">292: </a>{
<a name="line293">293: </a>  <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>          *cn = (<A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>*)ts-&gt;data;

<a name="line297">297: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(ts-&gt;vec_sol,&amp;cn-&gt;update);
<a name="line298">298: </a>  <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(ts-&gt;vec_sol,&amp;cn-&gt;func);
<a name="line299">299: </a>  <A href="../../../../../docs/manualpages/SNES/SNESSetFunction.html#SNESSetFunction">SNESSetFunction</A>(ts-&gt;snes,cn-&gt;func,TSCnFunction,ts);
<a name="line300">300: </a>  <A href="../../../../../docs/manualpages/SNES/SNESSetJacobian.html#SNESSetJacobian">SNESSetJacobian</A>(ts-&gt;snes,ts-&gt;A,ts-&gt;B,TSCnJacobian,ts);
<a name="line301">301: </a>  <font color="#4169E1">return</font>(0);
<a name="line302">302: </a>}
<a name="line303">303: </a><font color="#B22222">/*------------------------------------------------------------*/</font>

<a name="line307">307: </a><strong><font color="#4169E1"><a name="TSSetFromOptions_CN_Linear"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSSetFromOptions_CN_Linear(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line308">308: </a>{

<a name="line312">312: </a>  <A href="../../../../../docs/manualpages/KSP/KSPSetFromOptions.html#KSPSetFromOptions">KSPSetFromOptions</A>(ts-&gt;ksp);
<a name="line313">313: </a>  <font color="#4169E1">return</font>(0);
<a name="line314">314: </a>}

<a name="line318">318: </a><strong><font color="#4169E1"><a name="TSSetFromOptions_CN_Nonlinear"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSSetFromOptions_CN_Nonlinear(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line319">319: </a>{

<a name="line323">323: </a>  <A href="../../../../../docs/manualpages/SNES/SNESSetFromOptions.html#SNESSetFromOptions">SNESSetFromOptions</A>(ts-&gt;snes);
<a name="line324">324: </a>  <font color="#4169E1">return</font>(0);
<a name="line325">325: </a>}

<a name="line329">329: </a><strong><font color="#4169E1"><a name="TSView_CN"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> TSView_CN(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts,<A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer)</font></strong>
<a name="line330">330: </a>{
<a name="line332">332: </a>  <font color="#4169E1">return</font>(0);
<a name="line333">333: </a>}

<a name="line335">335: </a><font color="#B22222">/* ------------------------------------------------------------ */</font>
<a name="line336">336: </a><font color="#B22222">/*MC</font>
<a name="line337">337: </a><font color="#B22222">      <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A> - ODE solver using the implicit Crank-Nicholson method</font>

<a name="line339">339: </a><font color="#B22222">  Level: beginner</font>

<a name="line341">341: </a><font color="#B22222">.seealso:  <A href="../../../../../docs/manualpages/TS/TSCreate.html#TSCreate">TSCreate</A>(), <A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A>, <A href="../../../../../docs/manualpages/TS/TSSetType.html#TSSetType">TSSetType</A>()</font>

<a name="line343">343: </a><font color="#B22222">M*/</font>
<a name="line347">347: </a><strong><font color="#4169E1"><a name="TSCreate_CN"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  TSCreate_CN(<A href="../../../../../docs/manualpages/TS/TS.html#TS">TS</A> ts)</font></strong>
<a name="line348">348: </a>{
<a name="line349">349: </a>  <A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>          *cn;
<a name="line351">351: </a>  <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>            ksp;

<a name="line354">354: </a>  ts-&gt;ops-&gt;destroy         = TSDestroy_CN;
<a name="line355">355: </a>  ts-&gt;ops-&gt;view            = TSView_CN;

<a name="line357">357: </a>  <font color="#4169E1">if</font> (ts-&gt;problem_type == TS_LINEAR) {
<a name="line358">358: </a>    <font color="#4169E1">if</font> (!ts-&gt;A) {
<a name="line359">359: </a>      <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONGSTATE,<font color="#666666">"Must set rhs matrix for linear problem"</font>);
<a name="line360">360: </a>    }
<a name="line361">361: </a>    <font color="#4169E1">if</font> (!ts-&gt;ops-&gt;rhsmatrix) {
<a name="line362">362: </a>      ts-&gt;ops-&gt;setup  = TSSetUp_CN_Linear_Constant_Matrix;
<a name="line363">363: </a>      ts-&gt;ops-&gt;step   = TSStep_CN_Linear_Constant_Matrix;
<a name="line364">364: </a>    } <font color="#4169E1">else</font> {
<a name="line365">365: </a>      ts-&gt;ops-&gt;setup  = TSSetUp_CN_Linear_Variable_Matrix;
<a name="line366">366: </a>      ts-&gt;ops-&gt;step   = TSStep_CN_Linear_Variable_Matrix;
<a name="line367">367: </a>    }
<a name="line368">368: </a>    ts-&gt;ops-&gt;setfromoptions  = TSSetFromOptions_CN_Linear;
<a name="line369">369: </a>    <A href="../../../../../docs/manualpages/KSP/KSPCreate.html#KSPCreate">KSPCreate</A>(ts-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;ts-&gt;ksp);
<a name="line370">370: </a>    <A href="../../../../../docs/manualpages/TS/TSGetKSP.html#TSGetKSP">TSGetKSP</A>(ts,&amp;ksp);
<a name="line371">371: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSetInitialGuessNonzero.html#KSPSetInitialGuessNonzero">KSPSetInitialGuessNonzero</A>(ksp,<A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>);
<a name="line372">372: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (ts-&gt;problem_type == TS_NONLINEAR) {
<a name="line373">373: </a>    ts-&gt;ops-&gt;setup           = TSSetUp_CN_Nonlinear;
<a name="line374">374: </a>    ts-&gt;ops-&gt;step            = TSStep_CN_Nonlinear;
<a name="line375">375: </a>    ts-&gt;ops-&gt;setfromoptions  = TSSetFromOptions_CN_Nonlinear;
<a name="line376">376: </a>    <A href="../../../../../docs/manualpages/SNES/SNESCreate.html#SNESCreate">SNESCreate</A>(ts-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;ts-&gt;snes);
<a name="line377">377: </a>  } <font color="#4169E1">else</font> <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_OUTOFRANGE,<font color="#666666">"No such problem"</font>);

<a name="line379">379: </a>  <A href="../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(<A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>,&amp;cn);
<a name="line380">380: </a>  PetscLogObjectMemory(ts,<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/TS/TS_CN.html#TS_CN">TS_CN</A>));
<a name="line381">381: </a>  ts-&gt;data = (void*)cn;

<a name="line383">383: </a>  <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_SUP,<font color="#666666">"The code for Crank-Nicholson is not complete\n         emai petsc-maint@mcs.anl.gov for more info"</font>);
<a name="line384">384: </a>  <font color="#4169E1">return</font>(0);
<a name="line385">385: </a>}





</pre>
</body>

</html>
